/* ---------------------------------------------------------------------------
             Copyright (c) 2004-2005 Micrel, Inc.  All rights reserved.
   ---------------------------------------------------------------------------

    cliTable.h - The diagnostic cli command configuration table

    Author      Date        Description
    PCD         10/08/04    Created file.
   ---------------------------------------------------------------------------
*/

/* Include the required header files */
/* #include <inet/system.h> */
/*#include "stdio.h"*/
#include "target.h"



#define ARROW_U     101
#define ARROW_D     102
#define ARROW_R     103
#define ARROW_L     104


#ifdef _EZ80L92

extern COMMAND x_hwhelp_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[]  );
extern COMMAND x_hwread_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[]  );
extern COMMAND x_hwwrite_cmd( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwpoll_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwbufread_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwbufwrite_cmd( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwbuffill_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwbuftx_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwbufrx_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtableread_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtablewrite_cmd( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtableshow_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwclearmib_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwdumptx_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwdumprx_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwrepeat_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwreset_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtestcable_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgetlink_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwsetlink_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgetmac_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgetip_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgettxcnt1_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgettxcnt2_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgetrxcnt1_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwgetrxcnt2_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtxarp_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwrxthres_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwtxthres_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwearly_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwmagic_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwwolframe_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );
extern COMMAND x_hwclearpme_cmd ( struct shvars *Shl, DID stdin, DID stdout, DID stderr, WORD nargs, char *args[] );

#else

extern void  unknownDisplay ( void );
extern void  usagDisplay ( UINT16 );
extern int   hwhelp_cmd (void FAR *, void FAR **); 
extern int   hwread_cmd (void FAR *, void FAR **);
extern int   hwwrite_cmd (void FAR *, void FAR **);
extern int   hwpoll_cmd (void FAR *, void FAR **);
extern int   hwbufread_cmd (void FAR *, void FAR **);
extern int   hwbufwrite_cmd (void FAR *, void FAR **);
extern int   hwbuffill_cmd (void FAR *, void FAR **);
extern int   hwbuftx_cmd (void FAR *, void FAR **);
extern int   hwbufrx_cmd (void FAR *, void FAR **);
extern int   hwtableread_cmd  (void FAR *, void FAR **);
extern int   hwtablewrite_cmd (void FAR *, void FAR **);
extern int   hwtableshow_cmd (void FAR *, void FAR **);
extern int   hwclearmib_cmd (void FAR *, void FAR **);
extern int   hwdumptx_cmd (void FAR *, void FAR **);
extern int   hwdumprx_cmd (void FAR *, void FAR **);
extern int   hwrepeat_cmd (void FAR *, void FAR **);
extern int   hwreset_cmd (void FAR *, void FAR **);
extern int   hwtestcable_cmd (void FAR *, void FAR **);
extern int   hwgetlink_cmd (void FAR *, void FAR **);
extern int   hwsetlink_cmd (void FAR *, void FAR **);
extern int   hwgetmac_cmd (void FAR *, void FAR **);
extern int   hwgetip_cmd (void FAR *, void FAR **);
extern int   hwgettxcnt1_cmd (void FAR *, void FAR **);
extern int   hwgettxcnt2_cmd (void FAR *, void FAR **);
extern int   hwgetrxcnt1_cmd (void FAR *, void FAR **);
extern int   hwgetrxcnt2_cmd (void FAR *, void FAR **);
extern int   hwtxarp_cmd (void FAR *, void FAR **);
extern int   hwrxthres_cmd (void FAR *, void FAR **);
extern int   hwtxthres_cmd (void FAR *, void FAR **);
extern int   hwearly_cmd (void FAR *, void FAR **);
extern int   hwmagic_cmd (void FAR *, void FAR **);
extern int   hwwolframe_cmd (void FAR *, void FAR **);
extern int   hwclearpme_cmd (void FAR *, void FAR **);

/* this section are for FAB QC testing only */

#ifdef KS_QC_TEST

extern int   qctxtest_cmd (void FAR *, void FAR **);
extern int   qcgetmib_cmd (void FAR *, void FAR **);
extern int   qcgetcable_cmd (void FAR *, void FAR **);
extern int   qcecho_cmd (void FAR *, void FAR **);

#endif

#endif /* #ifdef _EZ80L92 */

#ifdef KS_PCI_BUS
extern int   hwpciread_cmd (void FAR *, void FAR **);
#endif


/* This is the structure that is used by the cli Parser to parser diagnostic 
 * cli command.
 */
typedef struct cli_tbl_entry
{
    const char FAR *cliString;                        /* keyword to be searched the parser string. */
    UINT16 FAR      nArgc;                            /* number of parameter for cli routine */
    UINT16 FAR      indexHelpMsg;                     /* index to  usag message in hwHelpMsgStr[] */
#ifdef _EZ80L92
    SHELL_CMD       cproc;                            /* cli diagnostion Shell routine at eZ80L92 IPWorks Shell command. */
#else
    int    FAR    (*cliFunc)(void FAR *, void FAR **); /* cli diagnostion routine. */

#endif /* #ifdef _EZ80L92 */

} CLI_TBL_ENTRY;
    


#define CLI_TBL_END NULL

enum {
#ifdef KS_ISA_BUS
	HWHELP_MSG = 24,
#else
	HWHELP_MSG = 28,
#endif
	HWREAD_MSG,
	HWWRITE_MSG,
	HWPOLL_MSG,
	HWBUFREAD_MSG,
	HWBUFWRITE_MSG,
	HWBUFFILL_MSG,
	HWBUFTX_MSG,
	HWBUFRX_MSG,
    HWTABLEREAD_MSG,
    HWTABLEWRITE_MSG,
    HWTABLESHOW_MSG,
    HWCLEARMIB_MSG,
    HWDUMPTX_MSG,
    HWDUMPRX_MSG,
    HWRESET_MSG,
#ifdef DEF_KS8842
    HWREPEAT_MSG,
#endif /* #ifdef DEF_KS8842 */
#ifdef DEF_KS8841
#ifdef KS_ISA_BUS
    HWRXTHRES_MSG,
    HWTXTHRES_MSG,
    HWEARLY_MSG,
#endif /* #ifdef KS_ISA_BUS */
#endif /* #ifdef DEF_KS8841 */
    HWMAGIC_MSG,
    HWWOLFRAME_MSG,
    HWCLEARPME_MSG,
#ifdef KS_PCI_BUS
	HWPCIREAD_MSG,
	HWPCIWRITE_MSG,
#endif
    HWTESTCABLE_MSG,
    HWGETLINK_MSG,
    HWSETLINK_MSG,
    HWGETMAC_MSG,
    HWGETIP_MSG,
    HWGETTXCNT1_MSG,
    HWGETTXCNT2_MSG,
    HWGETRXCNT1_MSG,
    HWGETRXCNT2_MSG,
    HWTXARP_MSG,
#ifdef KS_QC_TEST
	QCTXTEST_MSG,
	QCGETMIB_MSG,
    QCGETCABLE_MSG,
    QCECHO_MSG,
#endif
    HW_LAST,
    HWNULL
};

/* each entry will be processed by cliParser() */


CLI_TBL_ENTRY cliTbl [] =
{
    {"hwhelp",         0,  HWHELP_MSG,          
#ifdef _EZ80L92
      x_hwhelp_cmd},
#else
      hwhelp_cmd},
#endif

    {"hwread",         3,  HWREAD_MSG,          
#ifdef _EZ80L92
      x_hwread_cmd},
#else
      hwread_cmd},
#endif

    {"hwwrite",        4,  HWWRITE_MSG,         
#ifdef _EZ80L92
      x_hwwrite_cmd},
#else
      hwwrite_cmd},
#endif

    {"hwpoll",         5,  HWPOLL_MSG,          
#ifdef _EZ80L92
      x_hwpoll_cmd},
#else
      hwpoll_cmd},
#endif

    {"hwbufread",      3,  HWBUFREAD_MSG,       
#ifdef _EZ80L92
      x_hwbufread_cmd},
#else
      hwbufread_cmd},
#endif

    {"hwbufwrite",     3,  HWBUFWRITE_MSG,      
#ifdef _EZ80L92
      x_hwbufwrite_cmd},
#else
      hwbufwrite_cmd},
#endif

    {"hwbuffill",      5,  HWBUFFILL_MSG,       
#ifdef _EZ80L92
      x_hwbuffill_cmd},
#else
      hwbuffill_cmd},
#endif

    {"hwbuftx",        6,  HWBUFTX_MSG,         
#ifdef _EZ80L92
      x_hwbuftx_cmd},
#else
      hwbuftx_cmd},
#endif

    {"hwbufrx",        2,  HWBUFRX_MSG,         
#ifdef _EZ80L92
      x_hwbufrx_cmd},
#else
      hwbufrx_cmd},
#endif

    {"hwtableread",    3,  HWTABLEREAD_MSG,     
#ifdef _EZ80L92
      x_hwtableread_cmd},
#else
      hwtableread_cmd},
#endif

    {"hwtablewrite",   4,  HWTABLEWRITE_MSG,    
#ifdef _EZ80L92
      x_hwtablewrite_cmd},
#else
      hwtablewrite_cmd},
#endif

    {"hwtableshow",    3,  HWTABLESHOW_MSG,     
#ifdef _EZ80L92
      x_hwtableshow_cmd},
#else
      hwtableshow_cmd},
#endif

    {"hwclearmib",    1,  HWCLEARMIB_MSG,     
#ifdef _EZ80L92
      x_hwclearmib_cmd},
#else
      hwclearmib_cmd},
#endif

    {"hwdumptx",       1,  HWDUMPTX_MSG,        
#ifdef _EZ80L92
      x_hwdumptx_cmd},
#else
      hwdumptx_cmd},
#endif

    {"hwdumprx",       1,  HWDUMPRX_MSG,        
#ifdef _EZ80L92
      x_hwdumprx_cmd},
#else
      hwdumprx_cmd},
#endif

    {"hwreset",        1,  HWRESET_MSG,        
#ifdef _EZ80L92
      x_hwreset_cmd},
#else
      hwreset_cmd},
#endif

#ifdef DEF_KS8842

    {"hwrepeat",       1,  HWREPEAT_MSG,        
#ifdef _EZ80L92
      x_hwrepeat_cmd},
#else
      hwrepeat_cmd},
#endif

#endif /* #ifdef DEF_KS8842 */

#ifdef DEF_KS8841
#ifdef KS_ISA_BUS

    {"hwrxthres",       1,  HWRXTHRES_MSG,        
#ifdef _EZ80L92
      x_hwrxthres_cmd},
#else
      hwrxthres_cmd},
#endif

    {"hwtxthres",       1,  HWTXTHRES_MSG,        
#ifdef _EZ80L92
      x_hwtxthres_cmd},
#else
      hwtxthres_cmd},
#endif

    {"hwearly",         1,  HWEARLY_MSG,        
#ifdef _EZ80L92
      x_hwearly_cmd},
#else
      hwearly_cmd},
#endif

#endif /* #ifdef KS_ISA_BUS */

#endif /* #ifdef DEF_KS8841 */

    {"hwmagic",         0,  HWMAGIC_MSG,        
#ifdef _EZ80L92
      x_hwmagic_cmd},
#else
      hwmagic_cmd},
#endif

    {"hwwolframe",      3,  HWWOLFRAME_MSG,        
#ifdef _EZ80L92
      x_hwwolframe_cmd},
#else
      hwwolframe_cmd},
#endif

    {"hwclearpme",      0,  HWCLEARPME_MSG,        
#ifdef _EZ80L92
      x_hwclearpme_cmd},
#else
      hwclearpme_cmd},
#endif

#ifdef KS_PCI_BUS
    {"hwpciread",      4,  HWPCIREAD_MSG,       hwpciread_cmd},
    {"hwpciwrite",     5,  HWPCIWRITE_MSG,      hwpciwrite_cmd},
#endif /* #ifdef KS_PCI_BUS */

    {"hwtestcable",     1,  HWTESTCABLE_MSG,        
#ifdef _EZ80L92
      x_hwtestcable_cmd},
#else
      hwtestcable_cmd},
#endif

    {"hwgetlink",       1,  HWGETLINK_MSG,        
#ifdef _EZ80L92
      x_hwgetlink_cmd},
#else
      hwgetlink_cmd},
#endif

    {"hwsetlink",       2,  HWSETLINK_MSG,        
#ifdef _EZ80L92
      x_hwsetlink_cmd},
#else
      hwsetlink_cmd},
#endif

    {"hwgetmac",        0,  HWGETMAC_MSG,          
#ifdef _EZ80L92
      x_hwgetmac_cmd},
#else
      hwgetmac_cmd},
#endif

    {"hwgetip",         0,  HWGETIP_MSG,          
#ifdef _EZ80L92
      x_hwgetip_cmd},
#else
      hwgetip_cmd},
#endif

    {"hwgettxcnt1",     0,  HWGETTXCNT1_MSG,          
#ifdef _EZ80L92
      x_hwgettxcnt1_cmd},
#else
      hwgettxcnt1_cmd},
#endif

    {"hwgettxcnt2",     0,  HWGETTXCNT1_MSG,          
#ifdef _EZ80L92
      x_hwgettxcnt2_cmd},
#else
      hwgettxcnt2_cmd},
#endif

    {"hwgetrxcnt1",     0,  HWGETRXCNT1_MSG,          
#ifdef _EZ80L92
      x_hwgetrxcnt1_cmd},
#else
      hwgetrxcnt1_cmd},
#endif

    {"hwgetrxcnt2",     0,  HWGETRXCNT1_MSG,          
#ifdef _EZ80L92
      x_hwgetrxcnt2_cmd},
#else
      hwgetrxcnt2_cmd},
#endif

    {"hwtxarp",         4,  HWTXARP_MSG,          
#ifdef _EZ80L92
      x_hwtxarp_cmd},
#else
      hwtxarp_cmd},
#endif


#ifdef KS_QC_TEST

    {"qctxtest",       2,  QCTXTEST_MSG,        qctxtest_cmd},
    {"qcgetmib",       2,  QCGETMIB_MSG,        qcgetmib_cmd},
    {"qcgetcable",     1,  QCGETCABLE_MSG,      qcgetcable_cmd},
    {"qcecho",         1,  QCECHO_MSG,          qcecho_cmd},

#endif

    {CLI_TBL_END,      0,  0,                   NULL}          /* must be last */
};



