/* ---------------------------------------------------------------------------
          Copyright (c) 2004-2005 Micrel, Inc.  All rights reserved.
   ---------------------------------------------------------------------------

   hw_ver.h - KS8842 Hardware Driver Version file

   ---------------------------------------------------------------------------
    Author  Date      Version  Description
    PCD     06/28/06  1.0.4    (1) Enable Switch Ports broacast storm protection at 10% percent rate.
    THa     06/29/06           (2) Add 1912 bytes large frame support.
    THa     06/07/06           (3) Hardware interrupts may not be disabled
                                   immediately after the register is written to.
    THa     06/02/06           (4) Define HardwareDisableInterruptSync.
    THa     06/02/06           (5) Add NO_STATS conditional.
    THa     04/06/06           (6) Implement AT93C46 EEPROM access functions.
    PCD     03/16/06  1.0.0    (1) Set QMU Rx Flow Control High Water Mark to 2KB as default for A4 device.
                               (2) Took out workaround (disable DMA flow control when link is half duplex mode)
                                   for "KS8841/2/P can't release backpressue". A4 device fix this problem.
                               (3) Add a definition "FIBER_100FX" (user has to define it) for KSZ8861/2 with 
                                   100BT FX fiber can't do auto-negotiation, we set 100BT/full duplex force mode 
                                   for this platform.
    THa     02/28/06           (4) Do not use HW_WRITE_BYTE because of limitation of
                                   some hardware platforms.
    THa     02/23/06           (5) Removed KS884X_HW conditional.
    THa     01/25/06           (6) Add HardwareWriteIntMask and HardwareWriteIntStat
                                   functions for 32-bit I/O access only.

    PCD     01/20/06  0.2.1    (1) Enable (a) Aggressive back off algorithm, 
                                          (b).No excessive collision drop.
                                          (c).Flow control. 
										  (d).Back pressure  
							   (2) Transfer dword-aligned data for performance.

    PCD     10/20/05  0.2.0    (1).HardwareSetup() includes enable WOL by magic packet.
                               (2).Added Wake-on-LAN APIs. 
                               (3).Fixed incorrect register offset to configure VLAN, 
                                   Switch MAC address, and Multicast address.

    PCD     06/16/05  0.1.5    Modify configure device switch functions by per-port.
    PCD     05/25/05  0.1.4    Modify the way to read\write table registers in KS_ISA_BUS interface.
    PCD     04/29/05  0.1.3    Correct reset device function, and check device ID for device.
    PCD     04/07/05  0.1.1    Added "OID_COUNTER_XMIT_INT", "OID_COUNTER_RCV_INT" for debug.
                               No TX_CTRL_FORWARD_ENABLE bit in the device verison 1.

    PCD     03/30/05  0.1.0    First release.
                               (1). CLI read\write device registers works.
                               (2). Driver Initialization device works .
                               (3). Driver Interrupt Server Routine works.
                               (4). Driver transmit packets to device port works.
                               (5). Driver receive packsts from device works.
    THa     02/23/04           Use inline functions to improve performance.
    THa     10/05/04           Updated for PCI version.
    THa     10/14/04           Updated with latest specs.
    THa     12/10/03  0.0.1    Created file.
   ---------------------------------------------------------------------------
*/

#define KS884X_VERSION		"1.0.4"     

